﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=6.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Dim UDPSocket1 As UDPSocket
	
	Private const deviceIp As String = "192.168.1.255"
	Private const devicePort As Int = 51042
End Sub

Sub Service_Create
	UDPSocket1.Initialize("UDP",devicePort,8192) ' buffer data trasmessi / ricevuti
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Public Sub invia(Msg As String) As Int
	Dim Data()    As Byte
	Data = Msg.GetBytes("UTF8")
	'Udpsock_SendPacket(packet)
	Udpsock_SendPacket(Data)
	Return 0
	
End Sub

Private Sub Udpsock_SendPacket(data() As Byte)
	Try
		Dim packet As UDPPacket
		packet.Initialize(data, deviceIp, devicePort)
		UDPSocket1.Send(packet)
		
	Catch
		Log("Udpsock_SendPacket: " & LastException)
	End Try
End Sub

Sub UDP_PacketArrived (Packet As UDPPacket)
     
	ToastMessageShow("Arrivano dati >" & Packet.Length , True)
	If Packet.HostAddress <> Main.IP Then     ' se non e' lo stesso device ad inviare
	Dim packet_type As Int
	Dim rdata As String
	'INFO.Text="reading"
	rdata = "text="& BytesToString(Packet.Data, 2, 1, "UTF8")
	Log(rdata)
	CallSub2(Main, "Ricezione",BytesToString(Packet.Data,0,Packet.Length,"utf-8"))
	
	End If
	
	'(BytesToString(Packet.Data,0,Packet.Length,"utf-8"))
	
	'packet_type=bc.IntsFromBytes(rdata)
	'INFO.Text=packet_type
	'audioStream.Write(Packet.data)
	'Log(Packet)

End Sub


'Returns the UDP broadcast address.
'Returns an empty string if not available.
Sub GetBroadcastAddress As String
	Dim niIterator As JavaObject
	niIterator = niIterator.InitializeStatic("java.net.NetworkInterface").RunMethod("getNetworkInterfaces", Null)
	Do While niIterator.RunMethod("hasMoreElements", Null)
		Dim ni As JavaObject = niIterator.RunMethod("nextElement", Null)
		If ni.RunMethod("isLoopback", Null) = False Then
			Dim addresses As List = ni.RunMethod("getInterfaceAddresses", Null)
			For Each ia As JavaObject In addresses
				Dim broadcast As Object = ia.RunMethod("getBroadcast", Null)
				If broadcast <> Null Then
					Dim b As String = broadcast
					Return b.SubString(1)
				End If
			Next
		End If
	Loop
	Return ""
End Sub

